 
namespace eval Composite {
 
    variable edit_data {
       R0lGODlhGAAYAOMAAAICBK2tmo2NgOXlztXVvzY2MlxcWfLy2///////////
       /////////////////////yH5BAEKAAgALAAAAAAYABgAAAR/EMlJq704awu2
       BkDQeRVIDERBTibhnuPWuugwiLLw7vagfj4XoGcDHGIX46FAMBWHzcxwKQD1
       QIej9GAQDozgrDYJoA3PRzGO8/p+08pstERrFrPxw7x0HaT/R0gUZUR+Ygdf
       GwY2h2JVHlOGWYkreSiCMgRyBpiQep2VoCujEQA7
    }
    variable edit [image create photo -data [set edit_data]]


    
    variable delete_data {
       R0lGODlhDwAPAKEAAP8AAICAgAAAAP///yH+Dk1hZGUgd2l0aCBHSU1QACH5
       BAEKAAMALAAAAAAPAA8AAAIxnI+AAxDbXJIstnesvlOLj2XWJyzVWEKNYIUi
       wEbu+RnyW4vhmk4p3IOkcqYBsWgqAAA7
    }
    variable delete [image create photo -data [set delete_data]]

variable e1 ""
variable e2 ""
variable nu12 ""
variable g12 ""
variable g23 ""
variable g13 ""
variable spweight ""
variable t ""
variable ang ""
variable title "mat 1"
variable matlist ""
variable lamlist ""
variable index -1
variable lamindex -1
variable currenttitle "mat 1"
variable cbdatamat
variable matname ""
variable ID 1
variable badd
variable bnew
variable bfr
variable bmodify
variable bcancel
variable lamadd
variable lammodify
variable lamcancel
variable lamclear
variable useangle 1 
variable numlayers
variable can
variable table
variable lamtable
variable units N-m-kg
variable currentunit N-m-kg
variable unit2 "N/m\u00b2"
variable unit3 "gr/m\u00b3"
variable unit1 m
variable massunit2 "gr/m\u00b2"
variable spweightunit "N/m\u00b3"
variable conv2
variable dens
variable length
variable ef         
variable er        
variable densityf         
variable densityr         
variable nuf         
variable nur  
variable gf
variable gr   
variable re100        
variable titlel
variable vac                 
variable cblayer 
variable remass
variable typel 
variable values
variable sc1 ""
variable sc2 ""
variable st1 ""
variable st2 ""
variable cort ""
variable considermat 1
variable topname 
variable mathick
  
}
proc Composite::calcuateconvmatirx { } { 
    variable conv2
    variable dens
    variable length
    variable spweightconv

    set conv2(N-m-kg,N-m-kg) 1.0
    set conv2(N-m-kg,N-cm-kg) 1.0e-4
    set conv2(N-m-kg,N-mm-kg) 1.0e-6
    set conv2(N-m-kg,Kp-cm-utm) [expr 1.0e-4/9.81]
    
    set conv2(N-cm-kg,N-m-kg) 1.0e4
    set conv2(N-cm-kg,N-cm-kg) 1.0
    set conv2(N-cm-kg,N-mm-kg) 1.0e-2
    set conv2(N-cm,Kp-cm-utm) [expr 1.0/9.81] 
	    
    set conv2(N-mm-kg,N-m-kg) 1.0e6
    set conv2(N-mm-kg,N-cm-kg) 1.0e-2
    set conv2(N-mm-kg,N-mm-kg) 1.0
    set conv2(N-mm-kg,Kp-cm-utm) [expr 1.0e2/9.81] 
    
    set conv2(Kp-cm-kg,N-m-kg) [expr 1.0e4*9.81]
    set conv2(Kp-cm-kg,N-cm-kg) 9.81
    set conv2(Kp-cm-kg,N-mm-kg) [expr 1.0e-2*9.81]
    set conv2(Kp-cm-utm,Kp-cm-utm) 1.0

     set dens(N-m-kg,N-m-kg) 1.0
    set dens(N-m-kg,N-cm-kg) 1.0e-6
    set dens(N-m-kg,N-mm-kg) 1.0e-9
    set dens(N-m-kg,Kp-cm-utm) [expr 1.0e-6/9.8]  

    set dens(N-cm-kg,N-m-kg) 1.0e6
    set dens(N-cm-kg,N-cm-kg) 1.0
    set dens(N-cm-kg,N-mm-kg) 1.0e-3
    set dens(N-cm-kg,Kp-cm-utm) [expr 1.0/9.8] 
	    
    set dens(N-mm-kg,N-m-kg) 1.0e9
    set dens(N-mm-kg,N-cm-kg) 1.0e3
    set dens(N-mm-kg,N-mm-kg) 1.0
    set dens(N-mm-kg,Kp-cm-utm) [expr 1.0e3/9.8] 
    
    set dens(Kp-cm-utm,N-m-kg) [expr 1.0e6*9.8]
    set dens(Kp-cm-utm,N-cm-kg) [expr 1.0*9.8]
    set dens(Kp-cm-utm,N-mm-kg) [expr 1.0e-3*9.8]
    set dens(Kp-cm-utm,Kp-cm-utm) 1.0

    set length(N-m-kg,N-m-kg) 1.0
    set length(N-m-kg,N-cm-kg) 100.0
    set length(N-m-kg,N-mm-kg) 1000.0
    set length(N-m-kg,Kp-cm-kg) 100.0
    
    set length(N-cm-kg,N-m-kg) 1.0e-2
    set length(N-cm-kg,N-cm-kg) 1.0
    set length(N-cm-kg,N-mm-kg) 10.0
    set length(N-cm-kg,Kp-cm-utm) 1.0
    
    set length(N-mm-kg,N-m-kg) 1.0e-3
    set length(N-mm-kg,N-cm-kg) 0.1
    set length(N-mm-kg,N-mm-kg) 1.0
    set length(N-mm-kg,Kp-cm-utm) 0.1
    
     set length(Kp-cm-utm,N-m-kg) 1.0e-2
     set length(Kp-cm-utm,N-cm-kg) 1.0
     set length(Kp-cm-utm,m-kg) 10.0
     set length(Kp-cm-utm,Kp-cm-utm) 1.0
    
}
##############################################################
#Comunitaction with GiD                             #
##############################################################
proc Composite::ComunicateWithGiD { op args } {
    variable units
    variable matlist
    variable lamlist
    variable mathick
  
    switch $op {
	"INIT" {
	    catch { array unset mathick }
	    Composite::calcuateconvmatirx
	    set PARENT [lindex $args 0]
	    upvar [lindex $args 1] ROW
	    set GDN [lindex $args 2]
	    set STRUCT [lindex $args 3]
	    set f [frame $PARENT.f]
	    Composite::InitWindow $f 
	    grid $f -row $ROW -column 0 -sticky nsew -columnspan 2 -pady 3 -padx 2
	    grid columnconf $f 0 -weight 1
	    grid rowconf $f 0 -weight 1
	   grid rowconf $PARENT $ROW -weight 1
	   grid columnconf $PARENT 0 -weight 1
	    upvar \#0 $GDN GidData
	    Composite::getvalues $GidData($STRUCT,VALUE,3) $GidData($STRUCT,VALUE,5) $GidData($STRUCT,VALUE,6) $GidData($STRUCT,VALUE,7) $GidData($STRUCT,VALUE,8)
	     
	    return ""
	 }
	 "SYNC" {
	    set GDN [lindex $args 0]
	    set STRUCT [lindex $args 1]
	    set values [ Composite::dump ]
	    set names [ Composite::infonames ]
	    DWLocalSetValue $GDN $STRUCT  "laminate_properties" $values
	    DWLocalSetValue $GDN $STRUCT  "win_info" $names
	    DWLocalSetValue $GDN $STRUCT  "numero_de_capas" [lindex $values 0]
	    DWLocalSetValue $GDN $STRUCT  "Units" $units
	    if { $matlist != "" } {
		set aux [base64::encode -maxlen 100000 $matlist]
		set aux [join [split $aux ] " " ]
		DWLocalSetValue $GDN $STRUCT  "matlist" $aux
	    } else {
		 DWLocalSetValue $GDN $STRUCT  "matlist" 0
	    }
	    if  { $lamlist != "" } {
		set aux [base64::encode -maxlen 100000 $lamlist]
		set aux [join [split $aux ] " " ]
		DWLocalSetValue $GDN $STRUCT  "lamlist" $aux
	    } else {
		 DWLocalSetValue $GDN $STRUCT  "lamlist" 0
	    }
	    if { [array exists mathick] } {
		set aux [base64::encode -maxlen 100000 [array get mathick] ]
		set aux [join [split $aux ] " " ] 
		DWLocalSetValue $GDN $STRUCT  "mathick" $aux
	    } else {
		DWLocalSetValue $GDN $STRUCT  "mathick" 0
	    }
	    return ""
	}
    }
}
proc Composite::InitWindow { top }  {
    variable cbdatamat
    variable badd
    variable bnew
    variable bfr
    variable bmodify
    variable bcancel
    variable lamadd
    variable lammodify
    variable lamcancel
    variable can
    variable matlist
    variable table
    variable lamtable 
    variable lamclear
    ##############################################################
    #creating the notebook to organize the information           #
    ##############################################################
    set nb [NoteBook $top.notebook -height 300 -width 550 ]
    set page1 [$nb insert end page1 -text Laminate]
    set page2 [$nb insert end page2 -text Materials]
    $nb raise page2
    grid $nb -column 0 -row 0 -sticky nsew
    grid columnconf $page1 0 -weight 1
    grid rowconf $page1 0 -weight 1
    grid columnconf $page2 0 -weight 1
    grid rowconf $page2 0 -weight 1
    ##############################################################
    #creating the page for materials information "Materials"     #
    ##############################################################
   
    set table ""
    set pw [PanedWindow $page2.pw -side left ]
    set pane1 [$pw add -weight 0]


    set title1 [TitleFrame $pane1.data -relief groove -bd 2 -ipad 6 \
	    -text "Data Entry" -side left]
    set f1 [$title1 getframe]
    set bgcolor [$f1 cget -background]

    # changed the DisabledBackground to be an option so as to work with tk8.3
    option add *Entry*DisabledBackground $bgcolor
    set lunitsmat [label $f1.lunitsmat -text Units -justify left]
    set cbunitsmat [ComboBox $f1.cbunitsmat -textvariable Composite::units -editable no \
	    -justify left -values [list N-m-kg N-cm-kg N-mm-kg Kp-cm-utm] -width 5]
    set command "Composite::unitsproc ;#"
    trace variable Composite::units w $command
    bind $cbunitsmat <Destroy> [list trace vdelete Composite::units w $command]
    set ldatatitle [label $f1.ldatatitle -text Name -justify left ]
    set edatatitle [entry $f1.edatatitle -textvariable Composite::title -width 8 \
	    -justify left  -bd 2 -relief sunken -bg white ] 
    bind $top <<fiber-resin>> "+ $edatatitle configure -state disabled "
    bind $top <<normal>> "+ $edatatitle configure -state normal "
     set lthick [label $f1.ldatat -text "Thickness" -justify left ]
    set ethick [entry $f1.edatat -textvariable Composite::t -width 4 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number"} \
	    -bg white ]
    bind $top <<fiber-resin>> "+ $ethick configure -state disabled "
    bind $top <<normal>> "+ $ethick configure -state normal "
    set lunitthick [label $f1.lunitthick -textvariable Composite::unit1 -width 7]
    set ldatae1 [label $f1.ldatae1 -text E1 -justify left]
    set edatae1 [entry $f1.edatae1 -textvariable Composite::e1 -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number"} \
	    -bg white ]
    bind $top <<fiber-resin>> "+ $edatae1 configure -state disabled "
    bind $top <<normal>> "+ $edatae1 configure -state normal "
    set lunite1 [label $f1.lunite1 -textvariable Composite::unit2 -width 7]
    set ldatae2 [label $f1.ldatae2 -text E2 -justify left]
    set edatae2 [entry $f1.edatae2 -textvariable Composite::e2 -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number"} \
	    -bg white ]
    bind $top <<fiber-resin>> "+ $edatae2 configure -state disabled "
    bind $top <<normal>> "+ $edatae2 configure -state normal "
    set lunite2 [label $f1.lunite2 -textvariable Composite::unit2 -width 7]
    set ldatanu12 [label $f1.ldatanu12 -text nu12 -justify left ]
    set edatanu12 [entry $f1.edatanu12 -textvariable Composite::nu12 -width 12 \
	    -justify left -width 8 -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number"} \
	    -bg white ]
    bind $top <<fiber-resin>> "+ $edatanu12 configure -state disabled "
    bind $top <<normal>> "+ $edatanu12 configure -state normal "
    set ldatag12 [label $f1.ldatag12 -text G12 -justify left ]
    set edatag12 [entry $f1.edatag12 -textvariable Composite::g12 -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number"} \
	    -bg white ]
     bind $top <<fiber-resin>> "+ $edatag12 configure -state disabled "
    bind $top <<normal>> "+ $edatag12 configure -state normal "
    set lunitg12 [label $f1.lunitg12 -textvariable Composite::unit2 -justify left]
    set ldatag13 [label $f1.ldatag13 -text G13 -justify left -width 7]
    set edatag13 [entry $f1.edatag13 -textvariable Composite::g13 -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number"} \
	    -bg white ]
    bind $top <<fiber-resin>> "+ $edatag13 configure -state disabled "
    bind $top <<normal>> "+ $edatag13 configure -state normal "
    set lunitg13 [label $f1.lunitg13 -textvariable Composite::unit2 -justify left -width 7]
    set ldatag23 [label $f1.ldatag23 -text G23 -justify left ]
    set edatag23 [entry $f1.edatag23 -textvariable Composite::g23 -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number"} \
	    -bg white ]
    bind $top <<fiber-resin>> "+ $edatag23 configure -state disabled "
    bind $top <<normal>> "+ $edatag23 configure -state normal "
    set lunitg23 [label $f1.lunitg23 -textvariable Composite::unit2 -justify left -width 7 ]
    set ldataspweight [label $f1.ldataspweight -text "Specific Weight" -justify left ]
    set edataspweight [entry $f1.edataspweight -textvariable Composite::spweight -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number"} \
	    -bg white ]
    bind $top <<fiber-resin>> "+ $edataspweight configure -state disabled "
    bind $top <<normal>> "+ $edataspweight configure -state normal "
    set lunitspweight [label $f1.lunitspweight  -textvariable Composite::spweightunit -justify left -width 7 ]

    set title11 [TitleFrame  $pane1.failure -relief groove -bd 2 -ipad 6 \
	    -text "Failure Theory (Tsai-Wu)" -side left]
    set f11 [$title11 getframe]
    set checkmat [checkbutton $f11.checkmat -variable Composite::considermat \
	    -takefocus 0 -text "Calculate Security\nFactor (PostProcess)"]
    set lstress [label $f11.lstress -text "Allowable Stresses" -justify left]
    set lsc1 [Label $f11.lsc1 -text Sc1 -justify left -helptext "Allowable compression stress in direction 1" ]
    set esc1 [entry $f11.esc1 -textvariable Composite::sc1  -width 7\
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number" }]
    bind $esc1 <FocusOut> Composite::updatestress
    set lunitsc1 [label $f11.lunitsc1 -textvariable Composite::unit2 -justify left -width 7 ]
    set lsc2 [Label $f11.lsc2 -text Sc2 -justify left -helptext "Allowable compression stress in direction 2"]
    set esc2 [entry $f11.esc2 -textvariable Composite::sc2 -width 7\
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number" }]
    set lunitsc2 [label $f11.lunitsc2 -textvariable Composite::unit2 -justify left -width 7 ]  
    set lst1 [Label $f11.lst1 -text St1 -justify left -helptext "Allowable traccion stress in direction 1"]
    set est1 [entry $f11.est1 -textvariable Composite::st1 -width 7\
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number" }]
    set lunitst1 [label $f11.lunitst1 -textvariable Composite::unit2 -justify left -width 7]
    set lst2 [Label $f11.lst2 -text St2 -justify left -helptext "Allowable traccion stress in direction 2"]
    set est2 [entry $f11.est2 -textvariable Composite::st2 -width 7\
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number" }]
    set lunitst2 [label $f11.lunitst2 -textvariable Composite::unit2 -justify left -width 7 ] 
     set lcort [Label $f11.lcort -text T -justify left -helptext "Allowable shear stress"]
    set ecort [entry $f11.ecort -textvariable Composite::cort -width 7\
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number" }]
    set lunitcort [label $f11.lunitcort -textvariable Composite::unit2 -justify left -width 7]   
    set bgcolor [$f1 cget -background] 
    Composite::failureupdate $esc1 $esc2 $est1 $est2 $ecort $bgcolor
    set command "Composite::failureupdate $esc1 $esc2 $est1 $est2 $ecort $bgcolor ;#"
    trace variable Composite::considermat w $command
    bind $f11.checkmat <Destroy> [list trace vdelete Composite::considermat w $command]
    
    grid $pw  -sticky nsew 
    grid rowconf $pw 1 -weight 1
    grid columnconf $pw 0 -weight 1
    grid columnconf $pane1 0 -weight 1
    grid rowconf $pane1 0 -weight 1
    
    grid $title1 -column 0 -row 0 -padx 2 -pady 2 -sticky nsew
#     grid rowconf $f1 4 -weight 1
    grid $ldatatitle -column 0 -row 0
    grid $edatatitle -column 1 -row 0 -columnspan 3 -sticky nswe
    grid $lthick -column 4 -row 0 
    grid $ethick -column 5 -row 0  -sticky nsew
    grid $lunitthick -column 6 -row 0 
    grid $lunitsmat -column 6 -row 0 
    grid $cbunitsmat -column 7 -row 0 -sticky nsew
    grid $ldatae1 -column 0 -row 1
    grid $edatae1 -column 1 -row 1 -sticky nswe
    grid $lunite1 -column 2 -row 1
    grid $ldatae2 -column 3 -row 1
    grid $edatae2 -column 4 -row 1 -sticky nswe
    grid $lunite2 -column 5 -row 1
    grid $ldatanu12 -column 6 -row 1 
    grid $edatanu12 -column 7 -row 1 -sticky nswe
    grid $ldatag12 -column 0 -row 2
    grid $edatag12 -column 1 -row 2 -sticky nswe
    grid $lunitg12 -column 2 -row 2
    grid $ldatag13 -column 3 -row 2
    grid $edatag13 -column 4 -row 2 -sticky nswe
    grid $lunitg13 -column 5 -row 2
    grid $ldatag23 -column 6 -row 2
    grid $edatag23 -column 7 -row 2 -sticky nswe
    grid $lunitg23 -column 8 -row 2 -sticky nw
    grid $ldataspweight -column 0 -row 3
    grid $edataspweight -column 1 -row 3 -sticky nswe
    grid $lunitspweight -column 2 -row 3 -sticky nw

    
    grid $title11 -column 0 -row 1  -padx 2 -pady 2 -sticky nsew
    grid rowconf $f11 8 -weight 1
    grid $checkmat -column 0 -row 0 -sticky sw
#    grid $lstress -column 0 -row 1 -sticky nw
    grid $lsc1 -column 1 -row 0 -sticky se
    grid $esc1 -column 2 -row 0 -sticky sew
    grid $lunitsc1 -column 3 -row 0 -sticky swe
    grid $lsc2 -column 4 -row 0 -sticky swe
    grid $esc2 -column 5 -row 0 -sticky sew
    grid $lunitsc2 -column  6 -row 0 -sticky swe
    grid $lcort -column 7 -row 0 -sticky swe
    grid $ecort -column 8 -row 0 -sticky sew
    grid $lunitcort -column 9 -row 0 -sticky swe
    grid $lst1 -column 1 -row 1 -sticky en
    grid $est1 -column 2 -row 1 -sticky new
    grid $lunitst1 -column 3 -row 1 -sticky nwe
    grid $lst2 -column 4 -row 1 -sticky nwe
    grid $est2 -column 5 -row 1 -sticky new
    grid $lunitst2 -column 6 -row 1 -sticky new

    
    set pane2 [$pw add -weight 1]
    set title2 [TitleFrame $pane2.table -relief groove -bd 2 -text "Materials List" \
	    -side left ]
    set f2 [$title2 getframe]
    set sw [ScrolledWindow $f2.scroll -scrollbar both ]
    set table [tablelist::tablelist $sw.table \
	    -columns {0 "Name" 0 "Thick" 0 "E1" 0 "E2" 0 "nu12" 0 "G12" 0 "G23" 0 "G13" 0 "Sp W" 0 "Sc1" 0 "Sc2" 0 "St1" 0 "St2" 0 "T"} \
	    -height 3 -width 50 -stretch all -background white -labelbg lightyellow \
	    -listvariable Composite::matlist]
    $sw setwidget $table
    bind [$table bodypath] <Double-ButtonPress-1> { Composite::edit $Composite::table } 
    set bbox [ButtonBox $f2.bbox1 -spacing 0 -padx 1 -pady 1 -homogeneous 0 ]
    $bbox add -image $Composite::edit -width 24 \
	    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Edit material" -command "Composite::edit $table"
    $bbox add -image $Composite::delete -width 24 \
	    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Delete material" -command "Composite::delete $table $edatatitle"
    set buttonfr [frame $pane1.bfr]
    set badd [button $buttonfr.badd -text Add  -width 10 -underline 0 \
	    -command "Composite::add $table $edatae1 $edatatitle $top" ]
    bind $badd <ButtonRelease> {
	    if { $Composite::considermat == 1 } { 
		set Composite::values "12 $Composite::e1 $Composite::e2 $Composite::g13 $Composite::g12 $Composite::g23 \
		    $Composite::nu12  $Composite::sc1 $Composite::sc2 $Composite::st1 $Composite::st2 $Composite::cort" 
	    } else {
		set Composite::values "7 $Composite::e1 $Composite::e2 $Composite::g13 $Composite::g12 $Composite::g23 \
		$Composite::nu12"
	    }
	    Composite::errorcntrl $Composite::values $Composite::can
	}
    set bnew [button $buttonfr.bnew -text New  -width 10 -underline 0 \
	    -command "Composite::add $table $edatae1 $edatatitle $top" ]
    bind $bnew <ButtonRelease> {
	if { $Composite::considermat == 1 } { 
	    set Composite::values "12 $Composite::e1 $Composite::e2 $Composite::g13 $Composite::g12 $Composite::g23 \
		$Composite::nu12  $Composite::sc1 $Composite::sc2 $Composite::st1 $Composite::st2 $Composite::cort" 
	} else {
		set Composite::values "7 $Composite::e1 $Composite::e2 $Composite::g13 $Composite::g12 $Composite::g23 \
	    $Composite::nu12"
	}
	Composite::errorcntrl $Composite::values $Composite::can
	set Composite::index -1
    } 
    set bmodify [button $buttonfr.modify -text Modify  -width 10 -underline 0 \
	    -command "Composite::add $table $edatae1 $edatatitle $top" ]
     bind $bmodify <ButtonRelease> {
	if { $Composite::considermat == 1 } { 
	    set Composite::values "12 $Composite::e1 $Composite::e2 $Composite::g13 $Composite::g12 $Composite::g23 \
		$Composite::nu12  $Composite::sc1 $Composite::sc2 $Composite::st1 $Composite::st2 $Composite::cort" 
	} else {
		set Composite::values "7 $Composite::e1 $Composite::e2 $Composite::g13 $Composite::g12 $Composite::g23 \
	    $Composite::nu12"
	}
	Composite::errorcntrl $Composite::values $Composite::can
    } 
    set bcancel [button $buttonfr.cancel -text Cancel  -width 10 -underline 0 \
	    -command "Composite::cancel $table $edatae1 $top"]
    set bfr [button $f1.bfr -text Fiber-Resin -width 10 -underline 0 \
	    -command "Composite::fiber-resin $top" ]
    grid $bfr -column 4 -row 4 -columnspan 3 -pady 3 -sticky nw
    grid $buttonfr -column 0 -row 2  -pady 6 -sticky nsew
    grid $badd -column 0 -row 0 -pady 3 -padx 3 -sticky nw
    grid $bnew -column 0 -row 0 -pady 3 -padx 3 -sticky nw
    grid $bmodify -column 1 -row 0 -pady 3 -padx 3 -sticky nw
    grid $bcancel -column 2 -row 0 -pady 3 -padx 3 -sticky nw
    grid remove $bnew
    grid remove $bmodify
    grid remove $bcancel
    bind $top <Alt-KeyPress-a> "+ tkButtonInvoke $badd"                
    bind $top <Alt-KeyPress-n> "+ tkButtonInvoke $bnew"
    bind $top <Alt-KeyPress-m> "+ tkButtonInvoke $bmodify"
    bind $top <Alt-KeyPress-c> "+ tkButtonInvoke $bcancel"
    bind $top <Alt-KeyPress-f> "+ tkButtonInvoke $bfr"
    grid columnconf $pane2  0 -weight 1
    grid rowconf $pane2 0 -weight 1
    grid columnconf $pane1  0 -weight 1
    
    grid $title2 -column 0 -row 0 -padx 2 -pady 2 -sticky nsew 
    grid columnconf $f2  0 -weight 1
    grid rowconf $f2 0 -weight 1


    grid $sw -column 0 -row 0 -sticky nsew
    grid $bbox -column 0 -row 1 -sticky nw
    #$nb compute_size
    ##############################################################
    #creating the page for laminate information "Laminate"       #
    ##############################################################
    
    set pw [PanedWindow $page1.pw -side top ]
    set pane1 [$pw add -weight 1]

    set title1 [TitleFrame $pane1.data -relief groove -bd 2 \
	    -text "Data Entry" -side left]
    set f1 [$title1 getframe]
    set lunitslam [label $f1.lunitslam -text Units -justify left]
    set cbunitslam [ComboBox $f1.cbunitslam -textvariable Composite::units -editable no \
	    -justify left -values [list N-m-kg N-cm-kg N-mm-kg Kp-cm-utm]]
    set command "Composite::unitsproc ;#"
    trace variable Composite::units w $command
    bind $cbunitslam <Destroy> [list trace vdelete Composite::units w $command]
    
    set ldatamat [label $f1.ldatamat -text "Material" -justify left ]
    set cbdatamat [ComboBox $f1.cb -textvariable Composite::matname  \
	    -values "" -editable 0]
  
    set ldataspin [label $f1.ldataspin -text "Number of layers" -justify left]
    set spin [SpinBox $f1.spdata -textvariable Composite::numlayers \
	    -range "1 1000 1" -width 2 -takefocus 1]
    set ldatat [label $f1.ldatat -text "Thickness" -justify left ]
    set edatat [entry $f1.edatat -textvariable Composite::t -width 4 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number"} \
	     -bg white]
     set lunithick [label $f1.lunithick -textvariable Composite::unit1 -justify left -width 5 ]
    

    set command "Composite::frmathick $edatat ;#"
    trace variable Composite::matname w $command
    bind $cbdatamat <Destroy> [list trace vdelete Composite::matname w $command]  

  set edataang [entry $f1.edataang -textvariable Composite::ang -width 4 \
	    -justify left -bd 2 -relief sunken -state normal -bg white -validate focusout \
	    -vcmd {string is double %P} -invcmd { WarnWin "Entry is not a number"}]
    set unitang [label $f1.unitang -text degrees -justify left]
    set bgcolor [$f1 cget -background]
    set check [checkbutton $f1.chdata -variable Composite::useangle \
	    -takefocus 0 -text "Fiber Angle"]
    Composite::update $edataang $bgcolor
    set command "Composite::update [list $edataang $bgcolor];#"
    trace variable Composite::useangle w $command
    bind $f1.chdata <Destroy> [list trace vdelete Composite::useangle w $command]
    
    grid $pw  -sticky nsew 
    grid columnconf $pw  1 -weight 1
    grid rowconf $pw 0 -weight 1
    grid columnconf $pane1  0 -weight 1
    grid rowconf $pane1 1 -weight 1
    grid $title1 -column 0 -row 0 -padx 2 -pady 2 -sticky nsew
    grid rowconf $f1 5 -weight 1
    grid columnconf $f1 3 -weight 1
    grid $lunitslam -column 0 -row 0 -sticky nw 
    grid $cbunitslam -column 1 -row 0 -sticky nsew -columnspan 3 -pady 3
    grid $ldatamat -column 0 -row 1 -sticky nw
    grid $cbdatamat -column 1 -row 1 -columnspan 3 -sticky nsew
    grid $ldataspin -column 0 -row 2 -sticky nw
    grid $spin -column 1 -row 2 -sticky nswe
    grid $ldatat -column 2 -row 2 -sticky nw
    grid $edatat -column 3 -row 2 -sticky nswe
    grid $lunithick -column 4 -row 2 -sticky nw
    grid $check -column 0 -row 3 -sticky nw
    grid $edataang -column 1 -row 3 -sticky nw
    grid $unitang -column 2 -row 3 -sticky nw
    
    
    set pane2 [$pw add -weight 1]
    set title2 [TitleFrame $pane2.table -relief groove -bd 2 -text "Laminate Composition" \
	    -side left ]
    set f2 [$title2 getframe]
    set sw [ScrolledWindow $f2.scroll -scrollbar both ]
    set lamtable [tablelist::tablelist $sw.table \
	    -columns { 0 "Material" 0 "Angle" 0 "Thick" 0 "Layers"} \
	    -height 40 -width 30 -stretch all -background white -labelbg lightyellow \
	    -listvariable Composite::lamlist -selectmode extended]
    $sw setwidget $lamtable
    set bbox [ButtonBox $f2.bbox1 -spacing 0 -padx 1 -pady 1 -homogeneous 0 ]
    $bbox add -image $Composite::edit -width 24 \
	    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Edit layer" -command "Composite::lamedit $lamtable"
    $bbox add -image $Composite::delete -width 24 \
	    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Delete layer" -command "Composite::lamdelete $lamtable $cbdatamat"
    
    set lamadd [button $f1.badd -text Add  -underline 1 -width 10 \
	    -command "Composite::lamadd $lamtable $cbdatamat"]
     bind $lamadd <ButtonRelease> {
	if { $Composite::matname == "" } {
	    WarnWin "Select a material"
	    catch { vwait $Composite::matname }
	}
	set Composite::values "2 $Composite::t " 
	Composite::errorcntrl $Composite::values $Composite::can
	if { $Composite::useangle == 1 } { 
	   set Composite::values "2 $Composite::ang " 
	    Composite::errorcntrl $Composite::values $Composite::can
	}
    }
    set lamclear [button $f1.bclear -text "Clear All" -width 10 -underline 2 \
	    -command "Composite::lamclear $lamtable"]
    set lammodify [button $f1.bmodify -text Modify  -width 10 -underline 1 \
	    -command "Composite::lamadd $lamtable $cbdatamat"]
    set lamcancel [button $f1.bcancel -text Cancel  -width 10 -underline 2 \
	    -command "Composite::lamcancel $lamtable $cbdatamat"]
   
    grid $lamadd -column 0 -row 4 -padx 2 -pady 6
    grid $lamclear -column 2 -row 4 -columnspan 2 -pady 6 -sticky nw
    grid $lammodify -column 0 -row 4 -columnspan 2 -pady 6 -sticky nw
    grid $lamcancel -column 2 -row 4 -columnspan 2 -pady 6 -sticky nw
    grid remove $lammodify
    grid remove $lamcancel
    bind $top <Alt-KeyPress-d> "tkButtonInvoke $lamadd"                
    bind $top <Alt-KeyPress-o> "tkButtonInvoke $lammodify"
    bind $top <Alt-KeyPress-n> "tkButtonInvoke $lamcancel"
    bind $top <Alt-KeyPress-e> "tkButtonInvoke $lamclear"          
    
    bind [$lamtable bodypath] <Double-ButtonPress-1> { Composite:::lamedit $Composite:::lamtable }
    bind [$lamtable bodypath] <ButtonPress-3> "Composite::popupmenu $lamtable %X %Y" 
    grid columnconf $pane2  0 -weight 1
    grid rowconf $pane2 0 -weight 1
    grid columnconf $pane2  0 -weight 1
    
    grid $title2 -column 0 -row 0 -padx 2 -pady 2 -sticky nsew 
    grid columnconf $f2  0 -weight 1
    grid rowconf $f2 0 -weight 1


    grid $sw -column 0 -row 0 -sticky nsew
    grid $bbox -column 0 -row 1 -sticky nw
    ##############################################################
    #creating canvas                                             #
    ##############################################################
    set title3 [TitleFrame $pane1.canvas -relief groove -bd 2 -text "Visual Description" \
	    -side left ]
    set f3 [$title3 getframe]
    set can [canvas $f3.can -relief flat -bd 1 -width 100 -height 50 -bg white \
	    -highlightbackground black]
    grid $title3 -column 0 -row 1 -sticky nsew
    grid columnconf $f3 0 -weight 1
    grid rowconf $f3 0 -weight 1
    grid $can -column 0 -row 0 -sticky nsew
    bind $can <Configure> "Composite::refresh $can"
}                
##############################################################
#              update Failure theory frame                      #
##############################################################
proc Composite::failureupdate { entry1 entry2 entry3 entry4 entry5 bgcolor } {
  variable considermat
  variable sc1
  variable sc2
  variable st1
  variable st2
  variable cort
	     
#      set sc1 ""; set sc2 "" ; set st1 "" ; set st2 "" ; set cort ""                
     foreach entry [list $entry1 $entry2 $entry3 $entry4 $entry5] {   
	if { $considermat == 1 } {
	    $entry configure -bg white -state normal
	} else {
	    $entry configure -state disabled
	     set sc1 ""; set sc2 "" ; set st1 "" ; set st2 "" ; set cort ""      
	}
    }
}
##############################################################
#              update Failure theory entries                      #
##############################################################
proc Composite::updatestress { } {
  variable sc1
  variable sc2
  variable st1
  variable st2
  variable cort
    set sc2 $sc1
    set st1 $sc1
    set st2 $sc1
    set cort $sc1
}
##############################################################
#dump result into tablelist for materials                    #
##############################################################
proc Composite::add { table entry entrytitle parent} {
 variable t
 variable e1         
 variable e2         
 variable nu12         
 variable g12         
 variable g23         
 variable g13 
 variable spweight 
 variable ID         
 variable title 
 variable index                   
 variable currenttitle   
 variable matlist   
 variable cbdatamat
 variable sc1
 variable sc2
 variable st1
 variable st2
 variable cort   
 variable considermat   
#     set e1 [expr double($e1)]
#     set e2 [expr double($e2)]
#     set nu12 [expr double($nu12)]
#     set g12 [expr double($g12)]
#     set g13 [expr double($g13)]
#     set g23 [expr double($g23)] 
		    
     if { $index == ""} {
	set index -1
    }
    set matnames ""
    set ipos1 0
    while { [lindex $matlist $ipos1] != "" } {
	set aux [lindex $matlist $ipos1]
	lappend matnames [lindex $aux 0]
	set ipos1 [ expr $ipos1+1 ]
    }
    foreach name $matnames {
	if { $title == $name }  {
	    if { $index == -1 } {
		WarnWin "Another Material with this name already exists.\nPlease select a different name" $table 
		focus $entrytitle
		$entrytitle selection range 0 end 
		catch { grid remove $Composite::bmodify}
		return
	    }
	}
    }
		
   
    if { $index == -1 } {
	if { $considermat == 1 } { 
	    $table insert end "[list $title "$t" [format %8g $e1] \
		    [format %8g $e2] [format %4.3f $nu12] [format %8g $g12] \
		    [format %8g $g23] [format %8g $g13] [format %8g $spweight] [format %8g $sc1] \
		    [format %8g $sc2] [format %8g $st1] [format %8g $st2] [format %8g $cort]]"
	} else {
	     $table insert end "[list $title "$t" [format %8.3g $e1] \
		    [format %8g $e2] [format %4.3f $nu12] [format %8g $g12] \
		    [format %8g $g23] [format %8g $g13] [format %8g $spweight] undef \
		   undef undef undef undef]"
	}
	$table see end
	incr ID
	set title "mat $ID"
	set t ""
	set e1 ""        
	set e2 ""        
	set nu12 ""        
	set g12 ""        
	set g13 ""        
	set g23 ""
	set sc1 ""
	set sc2  ""
	set st1 ""
	set st2  ""
	set cort ""
	set spweight ""
	set currenttitle $title
	catch { grid $Composite::badd }
	catch { grid remove $Composite::bmodify }
	catch { grid remove $Composite::bcancel }     
	catch { grid remove $Composite::bnew }
    } else {
	$table delete $index 
       if { $considermat == 1 } { 
	    $table insert $index "[list $title "$t" [format %8g $e1] \
		    [format %8g $e2] [format %4.3f $nu12] [format %8g $g12] \
		    [format %8g $g23] [format %8g $g13] [format %8g $spweight] [format %8g $sc1] \
		    [format %8g $sc2] [format %8g $st1] [format %8g $st2] [format %8g $cort]]"
	} else {
	     $table insert $index "[list $title "$t" [format %8g $e1] \
		    [format %8g $e2] [format %4.3f $nu12] [format %8g $g12] \
		    [format %8g $g23] [format %8g $g13] [format %8g $spweight] undef \
		   undef undef undef undef]"
	}
	$table see $index
	set title $currenttitle
	set t ""
	set e1 ""        
	set e2 ""        
	set nu12 ""        
	set g12 ""        
	set g13 ""        
	set g23 ""
	set sc1 ""
	set sc2  ""
	set st1 ""
	set st2  ""
	set cort ""
	set index -1
	set spweight ""
	catch {  grid $Composite::badd }
	catch {  grid remove $Composite::bmodify }
	catch {  grid remove $Composite::bcancel }
	catch { grid remove $Composite::bnew } 
	
    }
    set matnames ""
    set ipos1 0
    while { [lindex $matlist $ipos1] != "" } {
	set aux [lindex $matlist $ipos1]
	lappend matnames [lindex $aux 0]
	set ipos1 [ expr $ipos1+1 ]
    }
    $cbdatamat configure -values $matnames
    focus $entry
    event generate $parent <<normal>>
}                
##############################################################
#     Edit row  intro tablelist of materials               #
##############################################################
proc Composite::edit { table } {
 variable t
 variable e1         
 variable e2         
 variable nu12         
 variable g12         
 variable g23         
 variable g13 
 variable spweight  
 variable sc1
 variable sc2
 variable st1
 variable st2
 variable cort  
 variable title        
 variable index
 variable currenttitle 
 variable considermat 
    variable ef         
    variable er        
    variable densityf         
    variable densityr         
    variable nuf         
    variable nur 
    variable gf
    variable gr  
    variable re100        
    variable titlel
    variable vac                 
    variable remass
    variable typel   
    variable mathick  
    
    set currenttitle "$title" 
    set index [$table curselection]
    if { $index != "" } {
	set entry [$table get $index]
	set title [lindex $entry 0]
	set t [lindex $entry 1]
	set e1 [lindex $entry 2]
	set e2 [lindex $entry 3]
	set nu12 [lindex $entry 4]
	set g12 [lindex $entry 5]
	set g13 [lindex $entry 7]
	set g23 [lindex $entry 6]
	set spweight [lindex $entry 8]
	if { [lindex $entry 9] == "undef" } { 
	    set sc1 ""
	    set sc2 ""
	    set st1 ""
	    set st2 ""
	    set cort ""
	    set considermat 0
	} else {
	    set sc1 [lindex $entry 9]
	    set sc2 [lindex $entry 10]
	    set st1 [lindex $entry 11]
	    set st2 [lindex $entry 12]
	    set cort [lindex $entry 13]
	    set considermat 1
	}
	if { [info exists mathick($title) ] } {
	    set titlel "$title"
	    set ef [lindex $mathick($title) 1]
	    set er [lindex $mathick($title) 2]
	    set densityf [lindex $mathick($title) 3]
	    set densityr [lindex $mathick($title) 4]
	    set nuf [lindex $mathick($title) 5]
	    set nur [lindex $mathick($title) 6]
	    set gf [lindex $mathick($title) 7]
	    set gr [lindex $mathick($title) 8]
	    set re100 [lindex $mathick($title) 9]
	    set  vac [lindex $mathick($title) 10]
	    set remass [lindex $mathick($title) 11]
	    set typel [lindex $mathick($title) 12]
	}
	catch { grid $Composite::bmodify }
	catch { grid $Composite::bcancel }
	catch { grid $Composite::bnew }
	catch { grid remove $Composite::badd }
	
    }
} 
##############################################################
#     Cancel edit process intro tablelist of materials       #
##############################################################
proc Composite::cancel { table entry parent } {
 variable t
 variable e1         
 variable e2         
 variable nu12         
 variable g12         
 variable g23         
 variable g13
 variable sc1
 variable sc2
 variable st1
 variable st2
 variable cort     
 variable title        
 variable index
 variable currenttitle
variable spweight 
    $table see end
    set title $currenttitle
    set t ""
    set e1 ""        
    set e2 ""        
    set nu12 ""        
    set g12 ""        
    set g13 ""        
    set g23 ""
     set sc1 ""
    set sc2  ""
    set st1 ""
    set st2  ""
    set cort ""
    set spweight ""
    set index -1
    catch { grid $Composite::badd }
    catch { grid remove $Composite::bmodify }
    catch { grid remove $Composite::bcancel }     
    catch { grid remove $Composite::bnew }
    focus $entry
    event generate $parent <<normal>>
}
##############################################################
#   Delete  a row  intro tablelist of materials              #
##############################################################
proc Composite::delete { table widget} {
    variable can
    variable cbdatamat
    variable matlist
    variable lamlist
    set entry [$table curselection]
    set currentmat [lindex [$table get $entry] 0]
    foreach lam $lamlist {
	if { $currentmat == [lindex $lam 0] } {
	    set retval [tk_dialogRAMFull .gid.tempwinw {Dialog window} \
		    "This material ($currentmat) is used in laminate sequence\n\
		    Are you sure you want to delete it?" \
		    "" "" gidquestionhead 0 OK Cancel]
	if { $retval == 1 } { return }
	set putyes yes 
	}
    }
    if { $entry != "" } {
	if { [string index $entry 0] > [string index $entry end]} {
	$table delete [string index $entry end] [string index $entry 0]
	$table see [string index $entry end]
	}
	if { [string index $entry 0] <=  [string index $entry end]} {
	$table delete [string index $entry 0] [string index $entry end]
	$table see [string index $entry 0]
	}
    }   
    
    set matnames ""
    set ipos1 0
    while { [lindex $matlist $ipos1] != "" } {
	set aux [lindex $matlist $ipos1]
	lappend matnames [lindex $aux 0]
	set ipos1 [ expr $ipos1+1 ]
    }
    $cbdatamat configure -values $matnames
    eval [Composite::refresh $can ]
    focus $widget
}
##############################################################
#           Delete a row intro tablelist of laminate         #
##############################################################
proc Composite::lamdelete { table widget} {
    variable can
    variable cbdatamat
    variable matlist
    set indexs "" 
    for { set i [expr [llength [$table curselection ]]-1] } { $i >=0 } { incr i -1} {
	lappend indexs [ lindex [$table curselection ] $i]
	}
    foreach index $indexs {
	$table delete $index
    }   
    set matnames ""
    set ipos1 0
    while { [lindex $matlist $ipos1] != "" } {
	set aux [lindex $matlist $ipos1]
	lappend matnames [lindex $aux 0]
	set ipos1 [ expr $ipos1+1 ]
    }
    $cbdatamat configure -values $matnames
    eval [Composite::refresh $can ]
    catch { focus $widget }
}
##############################################################
#         Dump result intro tablelist of laminate            #
##############################################################
proc Composite::lamadd { table entry } {
 variable t         
 variable ang         
 variable matname         
 variable numlayers  
 variable useangle
 variable lamindex
 variable can   
    if { $lamindex == ""} {
	set lamindex -1
    }
    if { $lamindex == -1 } {
	if { $useangle == 1 } {
	    set t [expr double($t)]
	    set ang [expr double($ang)]
	    $table insert end "{$matname} [format %5.2f $ang] [format %6f $t] \
		    $numlayers"
	} else {  
	    set t [expr double($t)]
	    $table insert end "{$matname} undef [format %6f $t] \
		    $numlayers"
	}
	$table see end
    } 
    if { $lamindex != -1 } {
	$table delete $lamindex
	if { $useangle == 1 } {
	    set t [expr double($t)]
	    set ang [expr double($ang)]
	    $table insert $lamindex "{$matname} [format %5.2f $ang] [format %6f $t] \
		    $numlayers"
		        
	} else {  
	    set t [expr double($t)]
	    $table insert $lamindex "{$matname} undef [format %6f $t] \
		    $numlayers"
		                    
	}
	$table see $lamindex
	set lamindex -1
	set t ""        
	set ang ""        
	set matname ""        
	set numlayers 1
	eval [Composite::refresh $can ]
	focus $entry
	grid remove $Composite::lammodify
	grid remove $Composite::lamcancel
	grid $Composite::lamadd
	grid $Composite::lamclear
    }
    set t ""        
    set ang ""        
    set matname ""        
    set numlayers 1
    eval [Composite::refresh $can ]
    focus $entry
}                
##############################################################
#       Edit a row into tablelist of laminate                #
##############################################################
proc Composite::lamedit { table } {
 variable matname          
 variable t         
 variable ang         
 variable numlayers         
 variable useangle         
 variable lamindex    
    set lamindex [$table curselection]
    if { [llength $lamindex] > 1} {
	WarnWin "It is only possible edit one row at the same time" $table 
	return
    } 
    if { $lamindex != "" } {
	set entry [$table get $lamindex]
	set matname [lindex $entry 0]
	set t [lindex $entry 2]
	set ang [lindex $entry 1]
	set numlayers [lindex $entry 3]
	grid $Composite::lammodify
	grid $Composite::lamcancel
	grid remove $Composite::lamadd
	grid remove $Composite::lamclear
    }
} 
##############################################################
#        Cancel edit process into tablelist laminate         #
##############################################################
proc Composite::lamcancel { table entry } {
 variable matname
 variable t         
 variable ang         
 variable numlayers         
 variable useangle         
 variable lamindex         
    
    $table see end
    set matname ""
    set t ""        
    set ang ""        
    set numlayers 1        
    set lamindex -1
    set useangle 1
    grid remove $Composite::lammodify
    grid remove $Composite::lamcancel 
    grid $Composite::lamadd
    grid $Composite::lamclear
    focus $entry
}
##############################################################
#              update Fiber angle entry                      #
##############################################################
proc Composite::update { entry bgcolor } {
  variable useangle         
   variable ang       
    if { $useangle == 1 } {
	$entry configure -bg white -state normal
    } else {
	$entry configure -state disabled
	set ang ""
    }
}
##############################################################
#               Clear all values into laminate page          #
##############################################################
proc Composite::lamclear { table } {
    variable can
    variable lamlist
    $table delete 0 end
    set lamlist ""
    eval [Composite::refresh $can]
}
##############################################################
#          Draw visual description of sandwich               #
##############################################################
proc Composite::refresh { can } {
    variable lamlist       
    variable matlist 
    $can delete all
    set x [ winfo width $can ]
    set y [ winfo height $can ]
    set y [expr $y-16.0]
    set thick ""
    set t 0
    set matnames ""
    set ipos 0
    set aux ""
    set lamcolors ""
    set colors "moccasin green blue yellow pink gold azure orange violet \
	    brown darkgreen darkblue red cyan magenta DeepPink gray firebrick honeydew \
	    HotPink ivory IndianRed khaki lavender LawnGreen LightSalmon LightSeaGreen \
	    linen maroon MistyRose navy PaleGoldenrod peru plum purple SeaGreen SkyBlue \
	    thistle tomato turquoise wheat YellowGreen"


    $can create line [expr {$x-30}] [expr {.5*$y}] [expr {$x-30}] [expr {$y-15}] \
	-fill black -width 2 -arrow last
    $can create text [expr {$x-25}] [expr {$y-15}] -text "Z'" -anchor sw


    foreach mat $matlist {
	lappend aux [lindex $mat 0]
	lappend aux [lindex $colors $ipos]
	set ipos [expr $ipos+1]
    }
    array set matcolors $aux
    foreach mat $lamlist {
	set numlayer [lindex $mat 3]
	set t [expr $t+[lindex $mat 2]*$numlayer]
	if { $numlayer > 0 } {
	    for { set j 0 } { $j < $numlayer } { incr j } {
		lappend thick [lindex $mat 2]
		lappend matnames [lindex $mat 0]
		lappend lamcolors $matcolors([lindex $mat 0])
	    }
	    }
    }
    set yi 8.0
    set ipos 0
    foreach ti $thick {
	lappend yi [expr [lindex $yi $ipos]+($y*$ti)/$t]
	set ipos [expr $ipos+1]
    }
   
    set x0 25.0
    set x1 [expr $x-125.0]

    set n [expr [llength $yi]-1]
    for { set i 0 } { $i < $n } {incr i 1 } {
	$can create rectangle $x0 [lindex $yi $i] $x1 [lindex $yi [expr $i+1]] \
		-fill [lindex $lamcolors $i]
    }
    if { $lamlist == "" } {
	$can delete all
    } else {
	set yleg [font metrics current -linespace]
	set xleg [expr $x1+8] 
	set ipos 0
	foreach mat $matlist {
	    $can create rectangle $xleg [expr [lindex $yi 0]+$ipos*$yleg] [expr $xleg+10] \
		    [expr [lindex $yi 0]+($ipos+1)*$yleg] -fill $matcolors([lindex $mat 0])
	    $can create text [expr $xleg+14] [expr [lindex $yi 0]+$ipos*$yleg] \
		    -text [lindex $mat 0] -justify right -anchor nw
	    set ipos [expr $ipos+1] 
	}
    }    
}


##############################################################
#       Comuniation with GiD: dump results intro GiD         #
##############################################################
proc Composite::dump { } {
    variable matlist
    variable lamlist
    variable considermat
    set values ""
    set numlayer 0
    foreach layer $lamlist {
	set numlayer [expr $numlayer+[lindex $layer 3]]
    }
    lappend values $numlayer
    foreach layer $lamlist {
	set matname [lindex $layer 0]
	set numlayer [lindex $layer 3]
	foreach mat $matlist {
	    set currentmat [lindex $mat 0]
	    if { $matname == $currentmat } {
		for { set i 0 } { $i < $numlayer } { incr i } {
		    if { [lindex $mat 9] != "undef" } {
		        lappend values [lindex $mat 2] [lindex $mat 3] \
		            [lindex $mat 4] [lindex $mat 5] [lindex $mat 6] \
		            [lindex $mat 7] [lindex $mat 9] [lindex $mat 10] [lindex $mat 11] \
		            [lindex $mat 12] [lindex $mat 13] [lindex $layer 1] [lindex $layer 2] \
		            [lindex $mat 8]
		    } else {
		        lappend values [lindex $mat 2] [lindex $mat 3] \
		            [lindex $mat 4] [lindex $mat 5] [lindex $mat 6] \
		            [lindex $mat 7] 0.0 0.0 0.0 0.0 0.0 [lindex $layer 1] [lindex $layer 2] \
		            [lindex $mat 8]
		    } 
		}
	    }
	}
    }
    set values [join $values]
    set values [join $values]
    return $values
}

#############################################################################
#Comuniation with GiD: Create a list of materials names for open window     #
#############################################################################
proc Composite::infonames { } {
    variable matlist
    variable lamlist
    
    set nameslist ""
    
    foreach layer $lamlist {
	set matname [lindex $layer 0]
	set numlayer [lindex $layer 3]
	lappend nameslist $matname
	lappend nameslist $numlayer
    }
    lappend nameslist end
    return $nameslist
}
##############################################################################
#   Comunication with GiD: get the values of sandwich to show intro window    #
##############################################################################
proc Composite::getvalues { names matunit mat lam matfr} {
    variable cbdatamat
    variable can
    variable matlist ""
    variable lamlist ""
    variable units ""
    variable mathick
    set cbvalues ""
    set units $matunit
    if { $mat != 0 } { 
	set matlist [base64::decode $mat]
    }
    if { $lam !=0 } {
	set lamlist  [base64::decode $lam]
    } 
    if { $matfr != 0 } {
	array set mathick  [base64::decode $matfr]
    }
    foreach mat $matlist {
	lappend cbvalues [lindex $mat 0]
    }
  
    $cbdatamat configure -values $cbvalues
    Composite::refresh $can
} 

proc Composite::unitsproc { } {

    variable units
    variable unit2
    variable unit3
    variable unit1
    variable massunit2
    variable spweightunit
    variable currentunit
    variable conv2 
    variable dens
    variable length 
    
    variable t

    variable e1         
    variable e2         
    variable g12         
    variable g23         
    variable g13 
    variable spweight
    
     variable sc1
    variable sc2
    variable st1
    variable st2
    variable cort
    
    variable ef         
    variable er 
    variable gr
    variable gf       
    variable densityf         
    variable densityr         
    variable remass
	

    switch $units {
	"N-m-kg" {
	    set unit2 "N/m\u00b2"
	    set unit3 "gr/m\u00b3"
	    set unit1 m
	    set massunit2 "gr/m\u00b2"
	    set spweightunit "N/m\u00b3"
	}
	"N-cm-kg" {
	     set unit1 cm
	    set unit2 "N/cm\u00b2"
	    set unit3 "gr/cm\u00b3"
	    set massunit2 "gr/cm\u00b2"
	    set spweightunit "N/cm\u00b3"
	}
	"N-mm-kg" {
	     set unit1 mm
	    set unit2 "N/mm\u00b2"
	    set unit3 "gr/mm\u00b3"
	    set unit1 mm
	    set massunit2 "gr/mm\u00b2"
	    set spweightunit "N/mm\u00b3"
	}
	"Kp-cm-utm" {
	     set unit1 cm
	    set unit2 "Kp/cm\u00b2"
	    set unit3 "gr/cm\u00b3"
	     set massunit2 "gr/cm\u00b2"
	    set spweightunit "Kp/cm\u00b3"
	}
    }
    catch { set e1 [string trim [format %8g [expr $e1*$conv2($currentunit,$units)]]] }
    catch { set e2 [string trim [format %8g [expr $e2*$conv2($currentunit,$units)]]]  }
    catch { set g12 [string trim [format %8g [expr $g12*$conv2($currentunit,$units)]]]  }
    catch { set g13 [string trim [format %8g [expr $g13*$conv2($currentunit,$units)]]]  }
    catch { set g23 [string trim [format %8g [expr $g23*$conv2($currentunit,$units)]]]  }
    catch { set ef [string trim [format %8g [expr $ef*$conv2($currentunit,$units)]] ] }
    catch { set er [string trim [format %8g [expr $er*$conv2($currentunit,$units)]]]  }
    catch { set gr [string trim [format %8g [expr $gr*$conv2($currentunit,$units)]]]  }
    catch { set gf [string trim [format %8g [expr $gf*$conv2($currentunit,$units)]]]  }
    catch { set  densityf [string trim [format %8g [expr $densityf*$dens($currentunit,$units)]]]  } 
    catch { set  densityr [string trim [format %8g [expr $densityr*$dens($currentunit,$units)]]]  }
    catch {set remass [string trim [format %8g [expr $remass*$conv2($currentunit,$units)]]] }
    catch { set t [string trim [ format %8g [expr $t*$length($currentunit,$units)]]] }
    catch { set sc1 [string trim [ format %8g [expr $sc1*$conv2($currentunit,$units)]]] }
    catch { set sc2 [string trim [ format %8g [expr $sc2*$conv2($currentunit,$units)]]] }
    catch { set st1 [string trim [ format %8g [expr $st1*$conv2($currentunit,$units)]]] }
    catch { set st2 [string trim [ format %8g [expr $st2*$conv2($currentunit,$units)]]] }
    catch { set cort [string trim [ format %8g [expr $cort*$conv2($currentunit,$units)]]] }
    catch {set spweight [string trim [format %8g [expr $spweight*$dens($currentunit,$units)]]]}
    set currentunit $units
}    

proc Composite::fiber-resin { parent} {
    global tkPriv tcl_platform
    variable topname
    variable ef         
    variable er        
    variable densityf         
    variable densityr         
    variable nuf         
    variable nur 
    variable gf
    variable gr  
    variable re100        
    variable titlel
    variable vac                 
    variable remass
    variable typel   
    variable title
    variable mathick
   
 if { [info exists mathick($title) ] } {
	    set titlel "$title"
	    set ef [lindex $mathick($title) 1]
	    set er [lindex $mathick($title) 2]
	    set densityf [lindex $mathick($title) 3]
	    set densityr [lindex $mathick($title) 4]
	    set nuf [lindex $mathick($title) 5]
	    set nur [lindex $mathick($title) 6]
	    set gf [lindex $mathick($title) 7]
	    set gr [lindex $mathick($title) 8]
	    set re100 [lindex $mathick($title) 9]
	    set  vac [lindex $mathick($title) 10]
	    set remass [lindex $mathick($title) 11]
	    set typel [lindex $mathick($title) 12]
    } else {
	 set ef "" ; set nuf "" ; set densityf "" ; set er "" ; set nur "" ; set densityr "" ; set vac "" ; set titlel ""
	set remass "" ; set re100 ""  ; set typel ""; set gf ""; set gr ""
    }
    set topname $parent.fr
    catch {destroy $topname}
    toplevel $topname
    
    wm title $topname Fiber-Resin
    if { $tcl_platform(platform) == "windows" } {
	wm transient $topname [winfo toplevel [winfo parent $topname]]
    }
       
    grid columnconf $topname 0 -weight 1
    grid rowconf $topname 0 -weight 1
   
    set matnb [NoteBook $topname.matnb ]
    set matpage1 [$matnb insert end page1 -text "Fiber"]
    set matpage2 [$matnb insert end page2 -text "Resin" ]
    $matnb raise page1
    set titlef [TitleFrame $matpage1.fdata -relief groove -bd 2 -ipad 6 \
	    -text "Fiber" -side left]
    set ff [$titlef getframe]
    set lef [label $ff.lef -text "Young Modulus" -justify left ]
    set eef [entry $ff.eef -textvariable Composite::ef -width 8 \
	    -justify left -bd 2 -relief sunken ]
    set lunitef [label $ff.lunitef -textvariable Composite::unit2 -width 7]
    set ldensityf [label $ff.ldensityf -text "Density" -justify left]
    set edensityf [entry $ff.edensityf -textvariable Composite::densityf -width 8 \
	    -justify left -bd 2 -relief sunken ]
    set lunitdenf [label $ff.lunitdenf -textvariable Composite::unit3 -width 7]
    set lnuf [label $ff.lnuf -text "Possion coef." -justify left ]
    set enuf [entry $ff.enuf -textvariable Composite::nuf -width 8 \
	    -justify left -width 8 -bd 2 -relief sunken ]
    set lgf [label $ff.lgf -text "Shear Modulus" -justify left ]
    set egf [entry $ff.egf -textvariable Composite::gf -width 8 \
	    -justify left -bd 2 -relief sunken ]
    set lunitgf [label $ff.lunitgf -textvariable Composite::unit2 -width 7]

    set titler [TitleFrame $matpage2.rdata -relief groove -bd 2 -ipad 6 \
	    -text "Resin" -side left]
    set fr [$titler getframe]
    set ler [label $fr.lef -text "Young Modulus" -justify left ]
    set eer [entry $fr.eef -textvariable Composite::er -width 8 \
	    -justify left -bd 2 -relief sunken ]
    set luniter [label $fr.luniter -textvariable Composite::unit2 -width 7]
    set ldensityr [label $fr.ldensityr -text "Density" -justify left]
    set edensityr [entry $fr.edensityr -textvariable Composite::densityr -width 8 \
	    -justify left -bd 2 -relief sunken ]
    set lunitdenr [label $fr.lunitdenr -textvariable Composite::unit3 -width 7]
    set lnur [label $fr.lnur -text "Possion coef." -justify left ]
    set enur [entry $fr.enur -textvariable Composite::nur -width 8 \
	    -justify left -width 8 -bd 2 -relief sunken ]
     set lgr [label $fr.lgf -text "Shear Modulus" -justify left ]
    set egr [entry $fr.egf -textvariable Composite::gr -width 8 \
	    -justify left -bd 2 -relief sunken ]
    set lunitgr [label $fr.lunitgr -textvariable Composite::unit2 -width 7]

    set titlel1 [TitleFrame $topname.ldata -relief groove -bd 2 -ipad 6 \
	    -text "Material" -side left]
    set fl [$titlel1 getframe]
    set lunitsmat [label $fl.lunitsmat -text Units -justify left]
    set cbunitsmat [ComboBox $fl.cbunitsmat -textvariable Composite::units -editable no \
	    -justify left -values [list N-m-kg N-cm-kg N-mm-kg Kp-cm-utm] -width 5]
    set command " ;#"
    trace variable Composite::units w $command
    bind $cbunitsmat <Destroy> [list trace vdelete Composite::units w $command]
    set ltitlel [label $fl.ltitlel -text Name -justify left ]
    set etitlel [entry $fl.etitlel -textvariable Composite::titlel -width 8 \
	    -justify left  -bd 2 -relief sunken  ] 
    focus $etitlel
    set ltypel [label $fl.lef -text "Layer Type" -justify left ]
    set cbtypel [ComboBox $fl.cbtypel -textvariable Composite::typel -width 8 \
	    -editable no -values [list Uni Mat Roving]]
    set lre100 [Label $fl.lre100 -text "% Reinforcement" -justify left \
	    -helptext "% of Reinforcement per unit mass.\nItmust be between 0 and 1"]
    set ere100 [entry $fl.ere100 -textvariable Composite::re100 -width 8 \
	    -justify left -bd 2 -relief sunken ]
    set lvac [Label $fl.lvac -text "Vaccum Index" -justify left -helptext "It must be between 0 and 1"]
    set evac [entry $fl.evac -textvariable Composite::vac -width 8 \
	    -justify left -width 8 -bd 2 -relief sunken ]
    set lremass [Label $fl.lremass -text "Mass of Reinforcement" -justify left \
	    -helptext "Mass of R."]
    set eremass [entry $fl.eremass -textvariable Composite::remass -width 8 \
	    -justify left -bd 2 -relief sunken ]
    set lunitmass [label $fl.lunitmass -textvariable Composite::massunit2 -width 7]
    
    set fbuttons [frame $topname.fbuttons -bd 2 -relief sunken]
    set badd [button $fbuttons.badd -text Add  -underline 0 -width 10 \
	    -command "Composite::fradd $topname $parent"]
    set bcancel [button $fbuttons.bcancel -text Cancel  -underline 0 -width 10 \
	    -command "Composite::frcancel $topname"]
     
    bind $badd <ButtonRelease> {
	set Composite::values "12 $Composite::ef $Composite::nuf $Composite::densityf $Composite::gf\
		$Composite::er $Composite::nur $Composite::densityr $Composite::gf $Composite::vac $Composite::remass $Composite::re100"
	Composite::errorcntrl $Composite::values $Composite::topname
    }
   
    grid $titlel1 -column 0 -row 0 -padx 2 -pady 2 -sticky nsew
    grid rowconf $fl 6 -weight 1
    grid columnconf $fl 1 -weight 1
    grid $lunitsmat -column 0 -row 0 -sticky nswe
    grid $cbunitsmat -column 1 -row 0 -sticky nswe 
    grid $ltitlel -column 0 -row 1 -sticky nswe
    grid $etitlel -column 1 -row 1 -sticky nswe
    grid $ltypel -column 0 -row 2 -sticky nswe
    grid $cbtypel -column 1 -row 2 -sticky nswe
    grid $lre100 -column 0 -row 3 -sticky nswe
    grid $ere100 -column 1 -row 3 -sticky nswe
    grid $lvac -column 0 -row 4 -sticky nsew
    grid $evac -column 1 -row 4 -sticky nswe
    grid $lremass -column 0 -row 5 -sticky nswe
    grid $eremass -column 1 -row 5 -sticky nswe
    grid $lunitmass -column 2 -row 5 -sticky nswe
    
    grid $matnb -column 1 -row 0 -sticky nsew
    grid columnconf $matpage1  0 -weight 1
    grid rowconf $matpage1 0 -weight 1
    grid columnconf $matpage2  0 -weight 1
    grid rowconf $matpage2 0 -weight 1

    grid $titlef -column 0 -row 0 -sticky nsew
    grid rowconf $ff 4 -weight 1
    grid columnconf $ff 1 -weight 1
    grid $lef -column 0 -row 0 -sticky nswe
    grid $eef -column 1 -row 0  -sticky nswe
    grid $lunitef -column 2 -row 0 -sticky nswe
    grid $ldensityf -column 0 -row 1 -sticky nswe
    grid $edensityf -column 1 -row 1 -sticky nswe
    grid $lunitdenf -column 2 -row 1 -sticky nswe
    grid $lnuf -column 0 -row 2 -sticky nswe
    grid $enuf -column 1 -row 2 -sticky nswe
    grid $lgf -column 0 -row 3 -sticky nswe
    grid $egf -column 1 -row 3 -sticky nsew
    grid $lunitgf -column 2 -row 3 -sticky nsew

    grid $titler -column 0 -row 0  -sticky nsew
    grid rowconf $fr 4 -weight 1
     grid columnconf $fr 1 -weight 1
    grid $ler -column 0 -row 0 -sticky nswe
    grid $eer -column 1 -row 0  -sticky nswe
    grid $luniter -column 2 -row 0 -sticky nswe
    grid $ldensityr -column 0 -row 1 -sticky nswe
    grid $edensityr -column 1 -row 1 -sticky nswe
    grid $lunitdenr -column 2 -row 1 -sticky nswe
    grid $lnur -column 0 -row 2 -sticky nswe
    grid $enur -column 1 -row 2 -sticky nswe
    grid $lgr -column 0 -row 3 -sticky nswe
    grid $egr -column 1 -row 3 -sticky nsew
    grid $lunitgr -column 2 -row 3 -sticky nsew
    
    grid $fbuttons -column 0 -row 1 -sticky nswe -columnspan 2 -pady 6
    grid $badd -column 0 -row 0 -pady 3 -padx 10
    grid $bcancel -column 1 -row 0 -pady 3 -padx 10

# set xpos [ expr [winfo x  [winfo toplevel $parent]]+50]
# set ypos [ expr [winfo y  [winfo toplevel  $parent]]+[winfo height [winfo toplevel  $parent]]/2-[winfo reqheight $topname]/2]
# wm geometry $topname +$xpos+$ypos

    wm withdraw $topname
#     update idletasks
    set xpos [ expr [winfo x  $parent]+[winfo width $parent]/2-[winfo reqwidth $topname]/2+100]
    set ypos [ expr [winfo y  $parent]+[winfo height $parent]/2-[winfo reqheight $topname]/2]

    wm geometry $topname +$xpos+$ypos
    wm deiconify $topname 

}

proc Composite::fradd { top parent} { 

    variable ef         
    variable er        
    variable densityf         
    variable densityr         
    variable nuf         
    variable nur 
    variable gf
    variable gr  
    variable re100        
    variable titlel
    variable vac                 
    variable remass
    variable typel   
   
    variable title
    variable t
    variable e1         
    variable e2         
    variable nu12         
    variable g12         
    variable g23         
    variable g13   
    
    variable mathick
    variable badd 
    
    set message ""
    if { $vac > 1 || $vac <0 } {
	set message  "Vaccum Index must be between 0 and 1\n"      
	set command1 vac    
    }
    if { $nur > 0.5 } {
	append message "Poisson coef. for Resin has to be samller than 0.5\n"
	 set command2 nur
    }
     if { $nuf > 0.5 } {
	append message "Poisson coef. for Fiber has to be samller than 0.5\n"
	 set command3 nuf
    }
    if { $re100>1 || $re100<0 } {
	set message  "%Reinforcement must be between 0 and 1\n"      
	set command4 re100
    }    
    set volume [expr ($re100*(1-$vac)/($re100+(1-$re100)*$densityf/$densityr))]
    if { $volume > 1 } {
	append message "Please, check the consistency of the following values:\n-%Reinforcement\n-Vaccum Index\n-Fiber Density\n-Fiber Resin"
	set command5 re100
    }

    if { $message != "" } { 
	WarnWin $message
	catch { vwait $command1 }
	catch { vwait $command2 }
	catch { vwait $command3 }
	catch { vwait $command4 }
	catch { vwait $command5 }
    }             
    
    set e1u [expr $volume*$ef+(1-$volume)*$er]
    set e2u [expr ($er/(1-pow($nur,2)))*((1+0.85*pow($volume,2))/(pow(1-$volume,1.25)+$volume*$er/($ef*(1-pow($nur,2)))))]
    set esp [expr ($remass/(1-$vac))*(1/$densityf+(1-$re100)/($re100*$densityr))*pow(10,-6)]
    set t [format %.3g $esp]
    set nu12 [format %f [expr {$nuf*(1-$re100)+$nur*$re100}]]
    set g12 [format %g [expr {$gr/double($re100+(1-$re100)*$gr/$gf)}]]
    set g13 $g12
    set aux [expr double(3-4.0*$nur+double($gr)/$gf)/4.0*(1-$nur)] 
    set g23 [format %g [expr {($gr*((1-$re100)+$aux*$re100))/($aux*$re100+(1-$re100)*$gr/$gf)}]]                   
    switch $typel {
	"Uni" {
	    if { $e1u < $e2u } {
		set title "$titlel"
		set e1 $e2u
		set e2 $e1u
	    } else {
		set title "$titlel"
		set e1 $e1u
		set e2 $e2u                                     
	    }
	}
	"Mat" {
	    set title "$titlel"
	    set e1 [expr 3.0*$e1u/8.0+5.0*$e2u/8.0]
	    set e2 [expr 3.0*$e1u/8.0+5.0*$e2u/8.0]
	}
	"Roving" {
	    set k [expr $e1u/($e1u+$e2u)]
	    set e1ro [expr $k*$e1u+(1-$k)*$e2u]
	    set e2ro [expr (1-$k)*$e1u+$k*$e2u]
	    if  { $e1ro < $e2ro } {
		set title "$titlel"
		set e1 $e1ro
		set e2 $e1ro               
	    } else {
		 set title "$titlel"
		set e1 $e2ro
		set e2 $e2ro
	    }
	}
    }
    set e1 [format %g $e1]
    set e2 [format %g $e2]
    set mathick($title) [list $esp $ef $er $densityf $densityr $nuf $nur $gf  $gr $re100 $vac $remass $typel]
    destroy $top
    event generate $parent <<fiber-resin>>
  
}
proc Composite::frcancel { top } {
    variable ef         
    variable er        
    variable densityf         
    variable densityr         
    variable nuf         
    variable nur   
    variable re100        
    variable titlel
    variable vac                 
    variable remass
    variable typel
    variable gf
    variable gr
    variable t ""
    variable e1 ""         
    variable e2 ""        
    variable nu12  ""        
    variable g12 ""        
    variable g23 ""         
    variable g13 ""
    variable title        
    variable currenttitle
    set title $currenttitle
    set ef "" ; set nuf "" ; set densityf "" ; set er "" ; set nur "" ; set densityr "" ; set vac "" ; set titlel ""
    set remass "" ; set re100 ""  ; set typel ""; set gf ""; set gr ""
    
    destroy $top
}

proc Composite::errorcntrl {values window} {
    set message ""
    if {[llength $values] != [lindex $values 0]  } {
	set message "Some entries are blank.\nPlease check for errors\n" 
	
    } else {
	set values [string range $values 1 end]
	foreach elem $values {
	    if { ! [string is double -strict $elem ] } {
		append message "- $elem - is not a valid input \n"
	    }
	}
    }
    if  { $message != "" } {
	WarnWin $message $window
	#tk_messageBox -message $message -type ok        
	return 1
    }
    return 0
}

proc Composite::frmathick { ethick } {

    variable mathick
    variable t
    variable useangle
    variable matname
    variable ang
    variable matlist
    if { [info exists mathick($matname) ] } { 
	set t [lindex $mathick($matname) 0]
	set useangle 0
	set ang ""
	$ethick configure -state disabled
    } else {
	foreach mat $matlist {
	    if { $matname == "[lindex $mat 0]" } {
		set t [lindex $mat 1]
	    }
	}
	$ethick configure -state normal
    }
}
##############################################################################
#   
# 
#                              Pop up menu of laminate table    #
# 
# 
# #############################################################################

proc Composite::popupmenu { parent x y } {
    variable lamtable 
    catch { destroy $parent.menu }
    set menu [menu $parent.menu -type normal ]
    $menu add command -label Paste -command Composite::poppaste
    $menu add command -label Sym+Paste -command Composite::popsympaste
    $menu add command -label Delete -command "Composite::lamdelete $lamtable {}"
    tk_popup $menu $x $y
   
} 

proc Composite::poppaste { } {
    variable lamtable 
    variable can
    set indexs [$lamtable curselection ]
    foreach index $indexs {
	$lamtable insert end [$lamtable get $index]
    }
    Composite::refresh $can
}
proc Composite::popsympaste { } {
    variable lamtable 
    variable can
    set indexs ""
    for { set i [expr [llength [$lamtable curselection ]]-1] } { $i >=0 } { incr i -1} {
	lappend indexs [ lindex [$lamtable curselection ] $i]
    }  
    foreach index $indexs {
	$lamtable insert end [$lamtable get $index]
    }
    Composite::refresh $can
}

    
     
